#include <asm/regdefs.h>

#if 0
#include <cachectl.h>
/*
 * Caches to flush
 */
#define ICACHE          0x1             /* flush instruction cache */
#define DCACHE          0x2             /* flush data cache        */
#define BCACHE          (ICACHE|DCACHE) /* flush both caches       */

/*
 * Caching modes
 */
#define CACHEABLE       0               /* mark cacheable          */
#define UNCACHEABLE     1               /* mark noncacheable       */
#endif

#define CACHELINES	512             /* number of cachelines    */

/*
 * Flush instruction/data caches
 *
 * Parameters: a0 - starting address to flush
 *             a1 - size of area to be flushed
 *             a2 - which caches to be flushed
 *
 * FIXME:      - ignores parameters
 *             - doesn't know about second level caches
 */

			.set	noreorder
			.globl	_cacheflush
			.text
_cacheflush:
			/*
			 * Flush the instruction cache
			 */
			lui	t0,0x8000
			li	t1,CACHELINES-1
1:			cache	0,0(t0)
			cache	0,32(t0)
			cache	0,64(t0)
			cache	0,96(t0)
			cache	0,128(t0)
			cache	0,160(t0)
			cache	0,192(t0)
			cache	0,224(t0)
			cache	0,256(t0)
			cache	0,288(t0)
			cache	0,320(t0)
			cache	0,352(t0)
			cache	0,384(t0)
			cache	0,416(t0)
			cache	0,448(t0)
			cache	0,480(t0)
			addiu	t0,t0,512
			bne	zero,t1,1b
			subu	t1,t1,1

			/*
			 * Flush the data cache
			 */
			lui	t0,0x8000
			li	t1,CACHELINES-1
1:                      cache   1,0(t0)
                        cache   1,32(t0)
                        cache   1,64(t0)
                        cache   1,96(t0)
                        cache   1,128(t0)
                        cache   1,160(t0)
                        cache   1,192(t0)
                        cache   1,224(t0)
                        cache   1,256(t0)
                        cache   1,288(t0)
                        cache   1,320(t0)
                        cache   1,352(t0)
                        cache   1,384(t0)
                        cache   1,416(t0)
                        cache   1,448(t0)
                        cache   1,480(t0)
                        addiu   t0,t0,512
                        bne     zero,t1,1b
                        subu    t1,t1,1

			j	ra
			nop

