#include <asm/mipsregs.h>
#include <linux/string.h>

#include "console.h"
#include <arc/types.h>

static char temp[1024];
extern ULONG stdout;

void
dump_tlb(void)
{
	int	i;
	int	wired;
	int	dummy;

	wired = read_32bit_cp0_register(CP0_WIRED);
	sprintf(temp, "Wird: %d\n\n", wired);
	Write(stdout, temp, strlen(temp), &dummy);
	
	for(i=0;i<=6;i++) {
		ULONG longs[2];

		write_32bit_cp0_register(CP0_INDEX, i);
		__asm__ __volatile__("tlbr");

		sprintf(temp, "Index: %2d PageMask: %8x\n\r", i,
			 read_32bit_cp0_register(CP0_PAGEMASK));
		Write(stdout, temp, strlen(temp), &dummy);

		read_64bit_cp0_register(longs,CP0_ENTRYHI);
		sprintf(temp, "EntryHi: %8x %8x\n\r", longs[1], longs[0]);
		Write(stdout, temp, strlen(temp), &dummy);

		read_64bit_cp0_register(longs,CP0_ENTRYLO0);
		sprintf(temp, "EntryLo0: %8x %8x\n\r", longs[1], longs[0]);
		Write(stdout, temp, strlen(temp), &dummy);

		read_64bit_cp0_register(longs,CP0_ENTRYLO1);
		sprintf(temp, "EntryLo1: %8x %8x\n\n\r", longs[1], longs[0]);
		Write(stdout, temp, strlen(temp), &dummy);
		}
}
