/*
 * Launch the kernel on a Deskstation Tyne
 *
 * Parameters: a0 - start address of the kernel image
 *             a1 - size of the kernel image in bytes without header
 *             a2 - size of the loaded RAM disk image
 *
 * To do: move all initialisation stuff which will only bloat the kernel
 *        after having once been executed to this file.
 */

#include <asm/mipsregs.h>
#include <asm/regdefs.h>

			.text
			.set	noreorder
			.globl	_launch
_launch:
			/*
			 * Disable Interrupts
			 */
			mfc0	t0,CP0_STATUS
			ori	t0,t0,1
			xori	t0,t0,1
			mtc0	t0,CP0_STATUS

			/*
			 * Move kernel image to 0x80000000
			 */
			la	t0,0x80000000
1:			lbu	t1,(a0)
			subu	a1,a1,1
			sb	t1,(t0)
			addiu	a0,a0,1
			bne	zero,a1,1b
			addiu	t0,t0,1

			/*
			 * a0 now points to the RAM disk image start address
			 */
			beq	zero,a2,2f
			lw	t0,_kernel_bss_end
1:			lbu	t1,(a0)
			subu	a2,a2,1
			sb	t1,(t0)
			addiu	a0,a0,1
			bne	zero,a2,1b
			addiu	t0,t0,1
2:

			jal	_cacheflush
		        nop

			/*
			 * launch the real thing
			 *
			 */
			lw	t0,_kernel_entry
			nop
			j	t0
			nop
