/*
 * btn (better than nothing) malloc(3)
 *
 * FIXME:
 * - chained lists are slow
 * - calloc(3) and realloc(3) aren't supported
 */

#include <arc/configuration.h>
#include <arc/errno.h>
#include <arc/memory.h>
#include <arc/proto.h>
#include <sys/types.h>

#include "malloc.h"

extern int _end;

struct mpool *_FirstChunk = NULL;
static inline int checkchunk(PMEMORY_DESCRIPTOR d)
{
    PVOID addr;

    addr = (PVOID)(d->BasePage << PAGE_SHIFT);

    /*
     * This function is a bugfix for the Deskstation Tyne ARC BIOS
     * which returns an memory descriptor for address
     * 0x84000000, size 0x400000. Maybe it's a BIOS bug in 1.3.017,
     * maybe it's just because I've got only 8mb installed which
     * conflicts with the specification.
     */
    if(addr == (PVOID) 0x04000000) return 0;
    if(d->MemoryType != MemoryFree) return 0;

    /*
     * Seems to be legal.
     */
    return 1;
}

void initmalloc(void)
{
    PMEMORY_DESCRIPTOR d = NULL;
    ULONG p, size, chunkend;

#if 0
printf("__end %x\r\n", &_end);
#endif
    while((d = GetMemoryDescriptor(d))) {
        /*
         * Add free RAM to list, do as if RAM is mapped to ksegx
         */
        if(checkchunk(d)) {
            p = (d->BasePage << PAGE_SHIFT) | KSEG0;
            size = d->PageCount << PAGE_SHIFT;
            if(p >= LOADADDR && p < (ULONG)&_end) {
#if 0
printf("Boeser Chunk bei %x %x\r\n", p, size);
#endif
                chunkend = p + size;
                p = ((ULONG)&_end) + (PAGESIZE-1);
                p = p & ~(PAGESIZE-1);
                size = chunkend - p;
#if 0
printf("gekuerzt bei %x %x\r\n", p, size);
#endif
                }
            ((struct mpool *)p)->NextChunk = _FirstChunk;
            ((struct mpool *)p)->Size      = size;
            _FirstChunk = (struct mpool *)p;
            }
        }
#if 0
printf("initmalloc:\r\n");
dumpmalloc();
#endif
}
