#include <sys/types.h>
#include <unistd.h>

#include <arc/types.h>
#include <arc/errno.h>
#include <arc/pathname.h>

ssize_t read(int fd, __ptr_t buf, size_t count)
{
    ULONG Count;
    _STATUS st;

#ifdef DEBUG
    printf("READ: %x, %d\r\n", buf, count);
#endif
    st = Read(fd, (PVOID) buf, (ULONG) count, &Count);
#ifdef DEBUG
    if(count != Count )
        printf("%d von %d\r\n", Count, count);
#endif
    if(st != ESUCCESS) {
#ifdef DEBUG
        printf("errno: %d\r\n", errno);
#endif
        errno = st;
        return -1;
        }


    return (int) Count;
}
